#include <stdlib.h>
#include <stdio.h>

#define MAX_M 5100
#define MAX_E 40010

struct edge {
  int a,b;
};

int N, K, M, F, a, b, i, j, z, wyn;
edge E[MAX_E];
int e_max;
int e[MAX_M];

int fac[MAX_M];
int popyt[MAX_M];
int col[MAX_M];

int queue_p, queue_k, queue[2*MAX_M];

int qsort_cmp (const void *a, const void *b)
{
  return ( ((edge *)a)->a - ((edge *)b)->a );
}

void clean()
{
  queue_p = queue_k = 0;
}

void push (int a)
{
  queue[queue_p++] = a;
  queue_p %= MAX_M;
}

int pop ()
{
  if (queue_k == queue_p) return -2;
  int wyn = queue[queue_k++];
  queue_k %= MAX_M;
  return wyn;
}

int find ()
{
  int odl = 0, i, koszt = 0, old = -5;
  clean ();
  for (int i = 1; i <= M; i++)
  {
    col[i] = 0;
    if (fac[i]) { col[i] = 1; push (i); }
  }
  push (-1);
  while (((i = pop ()) != -2) && !(i == -1 && old == -1))
  {
    old = i;
    if (i == -1) { odl++; push (-1); continue; }
    koszt += odl * popyt [i];
    koszt %= 100000;
    for (int j = e[i]; j < e[i+1]; j++)
      if (!col[E[j].b])
      {
	col[E[j].b] = 1;
	push (E[j].b);
      }
  }
  return koszt;
}

int main ()
{
  scanf ("%d\n", &N);
  for (z = 0; z < N; z++)
  {
    scanf ("%d %d %d\n", &M, &F, &K);
    e_max = 0;
    for (i = 1; i <= M; i++)
    {
      fac[i] = 0;
    }
    for (i = 0; i < F; i++)
    {
      scanf ("%d\n", &a);
      fac[a] = 1;
    }
    for (i = 1; i <= M; i++)
    {
      scanf ("%d\n", &popyt[i]);
    }
    for (i = 0; i < K; i++)
    {
      scanf ("%d %d\n", &a, &b);
      E[e_max].a = a; E[e_max].b = b;
      e_max++;
      E[e_max].a = b; E[e_max].b = a;
      e_max++;
    }
    qsort (E, e_max, sizeof (edge), &qsort_cmp);
    e[1] = 0;
    i = 1;
    while (i < e_max)
    {
      while (E[i-1].a == E[i].a) i++;
      if (i >= e_max) break;
      e[E[i].a] = i++;
    }
    e[E[e_max-1].a + 1] = i;
    printf ("%d\n", find());
  }
  return 0;
}
